<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

## World

### registerComponent

Register a component

#### Parameters

-   `Component` **Component** 

### registerSystem

Register a system

#### Parameters

-   `System` **[System][1]** 
-   `attributes`  

### getSystem

Return a registered system based on its class

#### Parameters

-   `SystemClass`  
-   `System` **[System][1]** 

### getSystems

Get all the systems registered

### execute

Update the systems per frame

#### Parameters

-   `delta` **[Number][2]** Delta time since the last call
-   `time` **[Number][2]** Elapsed time

### createEntity

Create a new entity

### stats

Get some stats

## Entity

### getComponent

Return an immutable reference of a component
Note: A proxy will be used on debug mode, and it will just affect
      the first level attributes on the object, it won't work recursively.

#### Parameters

-   `Component`  
-   `Type` **Component** of component to get

Returns **Component** Immutable component reference

### getMutableComponent

Return a mutable reference of a component.

#### Parameters

-   `Component`  
-   `Type` **Component** of component to get

Returns **Component** Mutable component reference

### addComponent

Add a component to the entity

#### Parameters

-   `Component` **Component** to add to this entity
-   `values`  
-   `Optional` **[Object][3]** values to replace the default attributes on the component

### removeComponent

Remove a component from the entity

#### Parameters

-   `Component` **Component** to remove from the entity
-   `forceRemove`  

### hasComponent

Check if the entity has a component

#### Parameters

-   `Component` **Component** to check
-   `include` **Bool** Components queued for removal (Default is false)

### hasAllComponents

Check if the entity has all components in a list

#### Parameters

-   `Components`  

### hasAnyComponents

Check if the entity has any components in a list

#### Parameters

-   `Components`  

### removeAllComponents

Remove all the components from the entity

#### Parameters

-   `forceRemove`  

### reset

Initialize the entity. To be used when returning an entity to the pool

### remove

Remove the entity from the world

#### Parameters

-   `forceRemove`  

## TagComponent

## System

## Not

Negate a component query

### Parameters

-   `Component`  

## createComponent

Create a component class from a schema

### Parameters

-   `schema`  
-   `name`  

## createType

Use createType to create custom type definitions.

### Parameters

-   `typeDefinition`  

## Types

Standard types

[1]: #system

[2]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number

[3]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object
